"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _tools = require("./tools");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const randomSeed = Math.random() * 10001;

/**

RandomizeNodePositions component, sets random positions to all nodes.
Can be used within Sigma component with predefined graph or within graph loader component.

**/
class RandomizeNodePositions extends _react.default.PureComponent {
  constructor(props) {
    super(props);
    let initSeed;

    if (this.props.seed != null) {
      initSeed = this.props.seed;
    } else {
      initSeed = Math.floor(Math.random() * 100001);
    }

    this.state = {
      seed: initSeed
    };

    if (this.props.sigma) {
      this.props.sigma.graph.nodes().forEach((n, idn) => {
        console.log(this.random());
        n.x = this.random();
        n.y = this.random();
      });
    }

    if (this.props.sigma) this.props.sigma.refresh();
  }

  random() {
    let s = Math.sin(this.state.seed++) * 10000;
    return s - Math.floor(s);
  }

  componentDidMount() {
    if (this.props.sigma) this.props.sigma.refresh();
  }

  render() {
    return /*#__PURE__*/_react.default.createElement("div", null, (0, _tools.embedProps)(this.props.children, {
      sigma: this.props.sigma
    }));
  }

}

_defineProperty(RandomizeNodePositions, "propTypes", {
  children: _propTypes.default.any,
  sigma: function () {
    return (typeof sigma === "function" ? _propTypes.default.instanceOf(sigma) : _propTypes.default.any).apply(this, arguments);
  },
  seed: _propTypes.default.number
});

var _default = RandomizeNodePositions;
exports.default = _default;